// ----------------------------------------------
// Listing zum Artikel 'Mathe schafft Natur -
// Algorithmische 3D-Landschaften in POV-Ray' 
// c't 20/03 Seite 206
//
// zweiter Schritt - f_noise3d() Funktion
//
// Szene fuer Persistence of Vision Ray Tracer 
// (POV-Ray) http://www.povray.org
// ----------------------------------------------
//

#version 3.5;

global_settings {
  assumed_gamma 1.0 
}

// ----------------------------------------

camera {
  location  <5.0, -12.0, 2.0>
  up z
  sky z
  look_at   <0.0, 0.0, 0.5> 
  angle 40
}

sky_sphere {
  pigment {
    gradient z
    color_map {
      [0.0 rgb <0.6,0.7,1.0>]
      [0.2 rgb <0.2,0.3,0.9>]
    }
  }
}

light_source {
  <3000, 1000, 2000>
  color rgb <2.2, 1.8, 1.5>
}   
   

// ----------------------------------------
                      
#include "functions.inc"                      
                      
#declare Relief_Funktion=function { z - f_noise3d(x, y, 0)*1.5 }

isosurface {
  function { Relief_Funktion(x, y, z) }
  
  contained_by {
    box { <-4, -4, -1>, <4, 4, 1.5> }
  } 
  
  texture { pigment { color rgb 1 } }
}